"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var shared_1 = require("../../shared");
/**
 * Componente base para implementar diálogos con un formulario. Típico caso de representación de sublistas
 */
var BaseDialogFormComponent = /** @class */ (function () {
    function BaseDialogFormComponent() {
        this.onSaveItem = new core_1.EventEmitter(true);
        this.onDeleteItem = new core_1.EventEmitter(true);
        this.onClose = new core_1.EventEmitter(true);
    }
    BaseDialogFormComponent.prototype.ngOnInit = function () {
        if (!this.item) {
            this.item = {};
        }
        this.myForm = this.createFormGroup();
    };
    BaseDialogFormComponent.prototype.saveItem = function () {
        var mensajeConfirmacion = this.item.id
            ? "Està segur que desitja modificar aquest element?"
            : "Està segur que desitja inserir el nou element?";
        if (confirm(mensajeConfirmacion)) {
            Object.assign(this.item, this.myForm.value);
            this.onSaveItem.emit(this.item);
        }
    };
    BaseDialogFormComponent.prototype.deleteItem = function () {
        if (confirm("Està segur que desitja eliminar aquest element?")) {
            this.onDeleteItem.emit(this.item.id);
        }
    };
    BaseDialogFormComponent.prototype.closeForm = function () {
        this.onClose.emit(this.item);
    };
    Object.defineProperty(BaseDialogFormComponent.prototype, "isEditMode", {
        get: function () {
            return this.mode === shared_1.FormType.Update;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BaseDialogFormComponent.prototype, "display", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], BaseDialogFormComponent.prototype, "mode", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BaseDialogFormComponent.prototype, "onSaveItem", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BaseDialogFormComponent.prototype, "onDeleteItem", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BaseDialogFormComponent.prototype, "onClose", void 0);
    return BaseDialogFormComponent;
}());
exports.BaseDialogFormComponent = BaseDialogFormComponent;
//# sourceMappingURL=base-dialog-form.component.js.map