"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ng2_file_upload_1 = require("ng2-file-upload");
var general_utils_service_1 = require("../service/general-utils.service");
var BitNGUploadComponent = /** @class */ (function () {
    function BitNGUploadComponent(generalUtils, changeDetector) {
        this.generalUtils = generalUtils;
        this.changeDetector = changeDetector;
        this.onSuccess = new core_1.EventEmitter();
        this.onError = new core_1.EventEmitter();
    }
    BitNGUploadComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.uploader.onSuccessItem = function (item, response, status, headers) {
            console.log("success upload file");
            _this.stopLoading();
            _this.onSuccess.emit({ item: item, response: response, status: status, headers: headers });
            if (_this.deleteItemAfterUpload) {
                item.remove();
            }
        };
        this.uploader.onErrorItem = function (item, response, status, headers) {
            console.log("error upload file");
            _this.stopLoading();
            _this.onError.emit({ item: item, response: response, status: status, headers: headers });
        };
        this.uploader.onProgressItem = function (item, progress) {
            console.log(progress);
            _this.changeDetector.detectChanges();
        };
        this.hasBaseDropZoneOver = false;
    };
    /** Arrancará el spinner en el caso de que la barra de progreso esté desactivada*/
    BitNGUploadComponent.prototype.startLoading = function () {
        if (!this.hasProgressBar) {
            this.generalUtils.startLoading();
        }
    };
    /** Parará el spinner en el caso de que la barra de progreso esté desactivada*/
    BitNGUploadComponent.prototype.stopLoading = function () {
        if (!this.hasProgressBar) {
            this.generalUtils.stopLoading();
        }
    };
    /** Sube todos los ficheros en cola al servidor */
    BitNGUploadComponent.prototype.uploadAll = function () {
        this.startLoading();
        this.uploader.uploadAll();
    };
    /** Elimina la cola de ficheros y deselecciona el fichero que pudiera estar seleccionado en el single input file */
    BitNGUploadComponent.prototype.removeQueue = function () {
        this.stopLoading();
        this.uploader.clearQueue();
        this.changeDetector.detectChanges();
        this.removeInputFile();
    };
    /** Cancela la subida de ficheros al servidor */
    BitNGUploadComponent.prototype.cancelQueue = function () {
        this.stopLoading();
        this.uploader.cancelAll();
    };
    /** Sube un fichero al servidor de manera individual */
    BitNGUploadComponent.prototype.uploadFile = function (item) {
        this.startLoading();
        item.upload();
    };
    /** Elimina de la cola un fichero en concreto y en el caso de que coincida con el seleccionado en el single input file, tambien
     * lo deselecciona
     */
    BitNGUploadComponent.prototype.removeFile = function (item) {
        this.stopLoading();
        if (this.fileInput && this.fileInput.nativeElement.value.indexOf(item.file.name) != -1) {
            this.removeInputFile();
        }
        item.remove();
    };
    /** Cancela la subida de un fichero de manera individual */
    BitNGUploadComponent.prototype.cancelFile = function (item) {
        this.stopLoading();
        item.cancel();
    };
    /** Deselecciona el fichero seleccionado en el input file */
    BitNGUploadComponent.prototype.removeInputFile = function () {
        if (this.fileInput)
            this.fileInput.nativeElement.value = "";
    };
    /** Evento que se dispara cuando arrastran un fichero a la zona de drag&drop */
    BitNGUploadComponent.prototype.fileOverBase = function (e) {
        this.hasBaseDropZoneOver = e;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", ng2_file_upload_1.FileUploader)
    ], BitNGUploadComponent.prototype, "uploader", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "hasDropZone", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "hasQueue", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "hasSingleUpload", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "hasMultipleUpload", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "deleteItemAfterUpload", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "canUpload", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitNGUploadComponent.prototype, "hasProgressBar", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], BitNGUploadComponent.prototype, "sizeDropZone", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], BitNGUploadComponent.prototype, "sizeQueue", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], BitNGUploadComponent.prototype, "onSuccess", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], BitNGUploadComponent.prototype, "onError", void 0);
    __decorate([
        core_1.ViewChild("fileRef", { static: false }),
        __metadata("design:type", Object)
    ], BitNGUploadComponent.prototype, "fileInput", void 0);
    BitNGUploadComponent = __decorate([
        core_1.Component({
            selector: "bit-ng-upload",
            template: "\n        <div class=\"row\">\n            <div class=\"col-md-{{sizeDropZone}} col-sd-12\">\n                <div *ngIf=\"hasDropZone\" \n                    ng2FileDrop\n                    [ngClass]=\"{'nv-file-over': hasBaseDropZoneOver}\"\n                    (fileOver)=\"fileOverBase($event)\"\n                    [uploader]=\"uploader\"\n                    class=\"well my-drop-zone\">\n                    Arrossegui aquí els fitxers que desitgi pujar\n                </div>\n                <div *ngIf=\"hasMultipleUpload\">\n                    Seleccioni més d'un fitxer\n                    <input type=\"file\" ng2FileSelect [uploader]=\"uploader\" multiple  /><br/>\n                </div>\n                <div *ngIf=\"hasSingleUpload\">\n                    Seleccioni un fitxer\n                    <input #fileRef type=\"file\" ng2FileSelect [uploader]=\"uploader\" />\n                </div>\n            </div>\n            <div *ngIf=\"hasQueue\" class=\"col-md-{{sizeQueue}} col-sd-12 queue\">\n                <p>Nombre de fitxers a pujar: {{ uploader?.queue?.length }}</p>\n                <table class=\"table\">\n                    <thead>\n                    <tr>\n                        <th width=\"50%\">Nom fitxer</th>\n                        <th *ngIf=\"uploader.options.isHTML5\">Tamany</th>\n                        <th *ngIf=\"uploader.options.isHTML5 && hasProgressBar\">Progrés</th>\n                        <th *ngIf=\"canUpload\">Estat</th>\n                        <th>Accions</th>\n                    </tr>\n                    </thead>\n                    <tbody>\n                    <tr *ngFor=\"let item of uploader.queue\">\n                        <td><strong>{{ item?.file?.name }}</strong></td>\n                        <td *ngIf=\"uploader.options.isHTML5\" nowrap>{{ item?.file?.size/1024 | number:'.2' }} KB</td>\n                        <td *ngIf=\"uploader.options.isHTML5 && hasProgressBar\">\n                            <div class=\"progress\" style=\"margin-bottom: 0;\">\n                                <div class=\"progress-bar\" role=\"progressbar\" [ngStyle]=\"{ 'width': item.progress + '%' }\"></div>\n                            </div>\n                        </td>\n                        <td *ngIf=\"canUpload\" class=\"text-center\">\n                            <span *ngIf=\"item.isSuccess\"><i class=\"glyphicon glyphicon-ok\"></i></span>\n                            <span *ngIf=\"item.isCancel\"><i class=\"glyphicon glyphicon-ban-circle\"></i></span>\n                            <span *ngIf=\"item.isError\"><i class=\"glyphicon glyphicon-remove\"></i></span>\n                        </td>\n                        <td nowrap>\n                            <button *ngIf=\"canUpload\" type=\"button\" class=\"btn btn-success btn-xs\"\n                                    (click)=\"uploadFile(item)\" [disabled]=\"item.isReady || item.isUploading || item.isSuccess\">\n                                <span class=\"glyphicon glyphicon-upload\"></span> Puja\n                            </button>\n                            <button *ngIf=\"canUpload\" type=\"button\" class=\"btn btn-warning btn-xs\"\n                                    (click)=\"cancelFile(item)\" [disabled]=\"!item.isUploading\">\n                                <span class=\"glyphicon glyphicon-ban-circle\"></span> Cancel·la\n                            </button>\n                            <button type=\"button\" class=\"btn btn-danger btn-xs\"\n                                    (click)=\"removeFile(item)\">\n                                <span class=\"glyphicon glyphicon-trash\"></span> Elimina de la cua\n                            </button>\n                        </td>\n                    </tr>\n                    </tbody>\n                </table>\n                <div>\n                    <div *ngIf=\"hasProgressBar\">\n                        Cua de progrés:\n                        <div class=\"progress\">\n                            <div class=\"progress-bar\" role=\"progressbar\" [ngStyle]=\"{ 'width': uploader.progress + '%' }\"></div>\n                        </div>\n                    </div>\n                    <div>\n                        <button *ngIf=\"canUpload\" type=\"button\" class=\"btn btn-success btn-s\"\n                                (click)=\"uploadAll()\" [disabled]=\"!uploader.getNotUploadedItems().length\">\n                            <span class=\"glyphicon glyphicon-upload\"></span> Pujat tot\n                        </button>\n                        <button *ngIf=\"canUpload\" type=\"button\" class=\"btn btn-warning btn-s\"\n                                (click)=\"cancelQueue()\" [disabled]=\"!uploader.isUploading\">\n                            <span class=\"glyphicon glyphicon-ban-circle\"></span> Cancel·la tot\n                        </button>\n                        <button type=\"button\" class=\"btn btn-danger btn-s\"\n                                (click)=\"removeQueue()\" [disabled]=\"!uploader.queue.length\">\n                            <span class=\"glyphicon glyphicon-trash\"></span> Elimina tot\n                        </button>\n                    </div>\n                </div>\n            </div>\n        </div>\n  ",
            styles: ["\n    .my-drop-zone { \n        border: dotted 3px lightgray; \n        display: flex;\n        justify-content: space-around;\n        flex-direction: row;\n    }\n\n    .nv-file-over { \n        border: dotted 3px red; \n    } /* Default class applied to drop zones on over */\n\n    .another-file-over-class { \n        border: dotted 3px green; \n    }\n\n    button {\n        margin-right: 5px;\n    }\n\n    .queue{\n        margin-top: 20px;\n    }\n\n    @media(min-width: 992px){\n        .queue{\n            margin-top: 0px;\n        }\n    }\n  "],
            changeDetection: core_1.ChangeDetectionStrategy.OnPush
        }),
        __metadata("design:paramtypes", [general_utils_service_1.GeneralUtils, core_1.ChangeDetectorRef])
    ], BitNGUploadComponent);
    return BitNGUploadComponent;
}());
exports.BitNGUploadComponent = BitNGUploadComponent;
//# sourceMappingURL=bit-ng-upload.component.js.map