import { RouterStateSnapshot, Params } from "@angular/router";
import { ActionReducerMap, ActionReducer, MetaReducer } from "@ngrx/store";
import * as fromRouter from "@ngrx/router-store";
export declare const ROUTER_STATE: string;
export declare function saveRouterStateIntoLocalStorage(routerState: any): void;
export declare function recoverRouterStateFromLocalStorage(): RouterStateUrl;
export interface RouterStateUrl {
    url: string;
    queryParams: Params;
    params: Params;
}
export interface AppState {
    routerReducer: fromRouter.RouterReducerState<RouterStateUrl>;
}
export declare const reducers: ActionReducerMap<AppState>;
export declare const getRouterReducerState: import("@ngrx/store").MemoizedSelector<object, fromRouter.RouterReducerState<RouterStateUrl>, import("@ngrx/store").DefaultProjectorFn<fromRouter.RouterReducerState<RouterStateUrl>>>;
export declare const getRouterStateUrl: import("@ngrx/store").MemoizedSelector<object, RouterStateUrl, import("@ngrx/store").DefaultProjectorFn<RouterStateUrl>>;
export declare class CustomSerializer implements fromRouter.RouterStateSerializer<RouterStateUrl> {
    serialize(routerSate: RouterStateSnapshot): RouterStateUrl;
}
/** An example of metareducer function that logs when an action is dispatched */
export declare function logger(reducer: ActionReducer<any>): ActionReducer<any>;
export declare const metaReducers: MetaReducer<AppState>[];
